import ATDLib.otaumata as ota
import ATDLib.diagotaumata as dota
import ATDLib.runatd as ratd
import ATDLib.canal as canal

from time import sleep
import threading as th

from random import sample,randint

def test(ota,dota,nb_run,alph,max_cons,size_min = 1,size_max = 20) :
    writer = ratd.ATDRunner(ota)
    listener = ratd.ATDRunner(dota)
    canal_entry = canal.Checker(writer,listener,'')

    alph = [a for a in alph if a in ota.trans]
    
    def gen_run(size) :
        for i in range(nb_run) :
            run = []
            for j in range(size) :
                run += ['#%.2f' % (randint(0,max_cons*10)/10)]
                run += [sample(alph,1)[0]]
            yield ','.join(run)

    print("Starting Tests for %s and %s" % (ota.name,dota.name))
    print(("Tests are done on %i runs for each size " % nb_run) +
          "of run between %i and %i" % (size_min,size_max))
    
    log_a = open('Test_log/log_%s.txt' % ota.name,'w')
    log_d = open('Test_log/log_%s.txt' % dota.name,'w')
    
    for size in range(size_min,size_max+1) :
        for run in gen_run(size) :
            canal_com = writer.write_on_canal()
            threads = [th.Thread(target = canal_entry.start),
                       th.Thread(target = writer.listen,
                                 args=(canal_entry,0.01,0,log_a)),
                       th.Thread(target = listener.listen,
                                 args=(canal_com,0.01,0,log_d))]  
            canal_entry.set_string(run)
            log_a.write('-'*80 + '\n' + run + '\n' + '-'*80 + '\n')
            log_d.write('-'*80 + '\n' + run + '\n' + '-'*80 + '\n')
            threads[0].start()
            threads[1].start()
            threads[2].start()
            while (canal_entry.running or canal_com.running or
                   threads[0].is_alive() or threads[1].is_alive() or
                   threads[2].is_alive() ) :
                sleep(0.01)
            else :
                sleep(0.01)
            if canal_entry.ex :
                print('Canal Entry Exit')
                input()
                exit()
                

            

    
