#!/usr/bin/env python3
from random import randint,sample
from itertools import product
from sys import argv,stdout
import os

# -d : e-deterministic ota
# -1 : no e-cycle
# -2 : no e-cycle that covers
# -e n : maximum n e-transition
# -r : erase previous
opt = [float('inf')] + [False]*3 # -d;-1;-2

args = []
argv = iter(argv)

for arg in argv :
    if arg[0] == '-' :
        for a in arg[1:] :
            o = { 'd' : 1, '1' : 2, '2' : 3 }.get(a,0)
            if o : opt[o] = True
            else :
                if arg == '-e' : opt[0] = int(next(argv)); continue
                else : print('Unknown option %s given' % a); exit()
    else : args.append(arg)

argv = args

def gen_ota(nb_s,alph0,max_cons,c_aut,nb_e,det,nocy,noco) :
    alph = alph0

    so = (('e' + str(opt[0]) if opt[0] != float('inf') else '') +
          ('d' if opt[1] else '') + ('1' if opt[2] else '') +
          ('2' if opt[3] else '') )
    fota = open("Examples/otatest_s%im%i_%s_%i.aut" %
                (nb_s,max_cons,so,c_aut),'w')

    fota.write("# States. Size : " + str(nb_s) + '\n')
    fota.write(';'.join([ 'q'+str(i) for i in range(nb_s)]) + '\n')

    fota.write("# Transitions\n")
    guard_pop = [(x,b) for (x,b) in product(range(max_cons),[False,True])]
    guard_pop += [(float('inf'),False)]

    # normal trans
    for a,q,l in product(alph,range(nb_s),range(nb_s)) :
        if randint(0,1) :
            bounds = sample(guard_pop,2)
            bounds = (min(bounds),max(bounds))
            guard = ( (']' if bounds[0][1] else '[') + str(bounds[0][0]) +
                      ','+ str(bounds[1][0]) + (']' if bounds[1][1] else '[') )
            fota.write(';'.join(['q'+str(q),guard,
                                 str(randint(0,1)),'q'+str(l),a]) + '\n')

    # e-trans
    n = len(guard_pop)
    nb_guard = ( ( n*(n+1)*(n+2) ) // 3 ) - 2
    trak_det = [ [ None ]*nb_s for q in range(nb_s) ]
    trak_vol = [ [ None ]*nb_s for q in range(nb_s) ]
    for q in range(nb_s) :
        trak_vol[q][q] = 0
    nb = 0
    for q,l in product(range(nb_s),range(nb_s)) :
        if nb >= nb_e : break
        if randint(0,2) : 
            bounds = sample(guard_pop,2)
            bounds = (min(bounds),max(bounds))
            if det :
                b = False
                for bounds_q in trak_det[q] :
                    if (bounds_q != None and
                        not ( bounds[0] >= bounds_q[1] or
                             bounds_q[0] >= bounds[1] )) :
                        b = True; break;
                
                if b : continue
            if noco or nocy :
                if l == q or trak_vol[l][q] != None :
                    if nocy : continue
                    elif bounds[1][0]-bounds[0][0] > 0 : continue
                    elif trak_vol[l][q] : continue
            nb += 1
            guard = ( (']' if bounds[0][1] else '[') +
                      str(bounds[0][0]) +
                      ','+ str(bounds[1][0]) +
                      (']' if bounds[1][1] else '[') )
            fota.write(';'.join(['q'+str(q),guard,
                                 str(randint(0,1)),
                                 'q'+str(l),'e']) + '\n')
            trak_det[q][l] = bounds
            for q1 in range(nb_s) :
                if trak_vol[q1][q] != None :
                    trak_vol[q1][l] = (trak_vol[q1][q] +
                                       bounds[1][0]-bounds[0][0])
    fota.close()

nb_to_gen = int(argv[1])
max_cons = int(argv[3])
alph = argv[4:]

temp_s = argv[2].split('-')
if len(temp_s) > 1 : nb_state = range(int(temp_s[0]),int(temp_s[-1])+1)
else : nb_state = [int(temp_s[0])]

for n in nb_state :
    print(("Generating {0} otaumata files with {1} states and {2} as maximum" +
      " constant on alphabet {3}").format(nb_to_gen,n,max_cons,alph))
    progress = 0
    print('[>>',end = '')
    for c in range(nb_to_gen) :
        gen_ota(n,alph,max_cons,c,*opt)
        if (c / nb_to_gen)*10 > progress :
            print('>>',end=''); stdout.flush()
            progress += 1
    print(']')

print("Generation finished")
print("To Generate automata and diagnozers" +
      "python files launch gen_diag.py ")
